<?php
/*
Plugin Name: Auto Header Generator
Plugin URI: http://www.de-mas.net/autoheader-wordpress-plugin/
Description: Este plugin genera los  META TAGS (title, description, keywords y robots) y el titulo de la pagina y los poner dentro del header, evitando el contenido duplicado y los resultados suplementarios.
Author: Eduard Fernandez
Version: 0.9
Author URI: http://www.de.mas.net/
*/ 

/*
Copyright 2007 Eduard Fernandez (eduardmail@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function generate_metas() 
{
	global $post;
	/* 
	- is_home() -
	- is_single() -
	- is_page() -
	- is_category() -
	is_author()
	- is_date() -
	is_archive()
	is_search()
	is_404() 
	is_paged()
	- is_tag() -
	*/

	$utw3check=1;
	/* Recogiendo la informacin para llenar las variables */
	$the_title=get_option('blogname'); /* Titulo del blog */
	$the_title_single=the_title('','',FALSE); /* Titulo del post */
	$the_descripcion=get_option('blogdescription'); /* Descripcion del blog */
	

	if (category_description())
	{
		$the_category_description=category_description(); /* Descripcin de la categora ... */
	} else {
		$cat = get_the_category(); 
		$cat = $cat[0];
		$the_category_description=$cat->category_description; /* Descripcin de la categoria ... */
		if (!($the_category_description))
		{
			$the_category_description=$the_descripcion; /* o la descripcin del blog para usarla como la de la categora */
			$description_excerpt = trim(substr(stripslashes(strip_tags($post->post_content)),0,150));
		}
	}

	if (single_cat_title('',FALSE))
	{
		$the_category_title=single_cat_title('',FALSE); /* Titulo de la categora ... */
	} else {
		$cat = get_the_category(); 
		$cat = $cat[0];
		$the_category_title=$cat->cat_name; /* Titulo de la categora ... */
		if (!($the_category_title))
		{
			$the_category_title=$the_title; /* o titulo del blog para usarlo como el de la categora */
		}
	}

	/* Palabras que no son necesario que aparezcan como keywords */
	$stop_words = array("-", "_", "/", ";", ".", ":", "<", ">", "'", "|","!","?","", "(", ")");
	$dic_stop_words = array("but,", "down,", "for,", "out,", "over,", "per,", "from,", "like,", "till,", "with,", "above,", "the,", "that,", "this,", "these,", "ante,", "con,", "desde,", "entre,", "es,", "hacia,", "hasta,", "para,", "por,", "sin,", "tras,", "los,", "las,", "unos,", "unas,","uno,", "una,", "del,", "de,");
	
	/* Keywords que deben de aparecer en todas las pginas */
	$the_kw[]="blog";
	$the_kw[]="weblog";
	$the_keywords="blog, weblog";

	if (is_home())
	{
		$line=$the_title." ".$the_descripcion;
		$line=strtolower($line);
		$line = str_replace(" ", ",", $line);
		$line = str_replace($stop_words, " ", $line);
		$line = str_replace($dic_stop_words, " ", $line);
		$trozos = explode(",", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (($trozo) && (strlen($trozo) > 2))
				{
					$the_kw[]=$trozo;
					$the_keywords.=", ".$trozo;
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_descripcion."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_title - $the_descripcion</title>", $header);
		print($header);
	}

	if (is_single())
	{
		global $utw;
		
		if (function_exists(is_utwtag)) {
			if ($utw->FormatTags($utw->GetTagsForPost($post->ID),array('first'=>'%tagdisplay%', 'default'=> ', %tagdisplay%'))) {
				$the_kw=explode(",", $utw->FormatTags($utw->GetTagsForPost($post->ID),array('first'=>'%tagdisplay%', 'default'=> ', %tagdisplay%')));
				$the_keywords=$the_keywords.", ".$utw->FormatTags($utw->GetTagsForPost($post->ID),array('first'=>'%tagdisplay%', 'default'=> ', %tagdisplay%'));
			}
		}
		if (isset($description_excerpt) && (strlen($description_excerpt) > 10)) 
		{
			$the_category_description=$description_excerpt;
			$the_category_description=str_replace("\n", " ", $the_category_description);
		} else {
			$the_category_description=$the_title_single.". ".$the_category_description;
		}
		$line=$the_title_single." ".$the_category_description;
		$line=strtolower($line);
		$line = str_replace(" ", ",", $line);
		$line = str_replace($stop_words, " ", $line);
		$line = str_replace(" ".$dic_stop_words, " ", $line);
		$trozos = explode(",", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (($trozo) && (strlen($trozo) > 2))
				{
					$the_kw[]=$trozo;
					$the_keywords.=", ".$trozo;
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_title_single."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_category_description."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_title_single</title>", $header);
		print($header);
	}

	if (is_page())
	{
		if (isset($description_excerpt) && (strlen($description_excerpt) > 10)) 
		{
			$the_descripcion=$description_excerpt;
			$the_descripcion=str_replace("\n", " ", $the_descripcion);
		} else {
			$the_descripcion=$the_title_single." - ".$the_descripcion;
		}

		$line=$the_title_single." ".$the_title." ".$the_descripcion;
		$line=strtolower($line);
		$line = str_replace(" ", ",", $line);
		$line = str_replace($stop_words, " ", $line);
		$line = str_replace($dic_stop_words, " ", $line);
		$trozos = explode(",", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (($trozo) && (strlen($trozo) > 2))
				{
					$the_kw[]=$trozo;
					$the_keywords.=", ".$trozo;
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_title_single." - ".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_descripcion."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_title_single - $the_title</title>", $header);
		print($header);
	}
		
	if (is_category())
	{
		$line=$the_category_title." ".$the_title." ".$the_category_description;
		$line=strtolower($line);
		$line = str_replace(" ", ",", $line);
		$line = str_replace($stop_words, " ", $line);
		$line = str_replace($dic_stop_words, " ", $line);
		$trozos = explode(",", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (($trozo) && (strlen($trozo) > 2))
				{
					$the_kw[]=$trozo;
					$the_keywords.=", ".$trozo;
				}
			}
		}
		/* Metas */
		echo "<meta name=\"title\" content=\"".$the_category_title." - ".$the_title."\" />\n";
		echo "<meta name=\"description\" content=\"".$the_category_title." - ".$the_category_description."\" />\n";
		echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
		/* Title */
		$header = ob_get_contents();
		ob_end_clean();
		$header = preg_replace("/<title>.*<\/title>/", "<title>$the_category_title - $the_title</title>", $header);
		print($header);
	}

	if (is_date())
	{
		$line=$the_title." ".$the_descripcion;
		$line=strtolower($line);
		$line = str_replace(" ", ",", $line);
		$line = str_replace($stop_words, " ", $line);
		$line = str_replace($dic_stop_words, " ", $line);
		$trozos = explode(",", $line);
		foreach ($trozos as $trozo) {
			$trozo=strtolower(trim ($trozo));
			if (!(in_array ($trozo, $the_kw)))
			{
				if (($trozo) && (strlen($trozo) > 2))
				{
					$the_kw[]=$trozo;
					$the_keywords.=", ".$trozo;
				}
			}
		}
		/* Metas */
		$the_wp_version=get_bloginfo('version');
		$the_wp_version = str_replace(".", "", $the_wp_version);
		if ($the_wp_version<210)
		{
			//$my_month = single_month_title(' ', true);
			global $m, $monthnum, $month, $year;
			if ( !empty($monthnum) && !empty($year) ) {
				$my_year = $year;
				$my_month = $month[str_pad($monthnum, 2, '0', STR_PAD_LEFT)];
			} elseif ( !empty($m) ) {
				$my_year = substr($m, 0, 4);
				$my_month = $month[substr($m, 4, 2)];
			} else {
				$my_year = " Date";
				$my_month = "No";
			}
			$title_date=$my_month." ".$my_year;
			echo "<meta name=\"title\" content=\"".$title_date." - ".$the_title."\" />\n";
			echo "<meta name=\"description\" content=\"".$title_date." - ".$the_descripcion."\" />\n";
			echo "<meta name=\"keywords\" content=\"".$my_month.", ".$my_year.", ".$the_keywords."\" />\n";
			$header = ob_get_contents();
			ob_end_clean();
			$header = preg_replace("/<title>.*<\/title>/", "<title>$my_month $my_year - $the_title</title>", $header);
			print($header);
		} else {
			$title_date=trim(single_month_title(' ', false));
			echo "<meta name=\"title\" content=\"".$title_date." - ".$the_title."\" />\n";
			echo "<meta name=\"description\" content=\"".$title_date." - ".$the_descripcion."\" />\n";
			echo "<meta name=\"keywords\" content=\"".$title_date.", ".$the_keywords."\" />\n";
			$header = ob_get_contents();
			ob_end_clean();
			$header = preg_replace("/<title>.*<\/title>/", "<title>".$title_date." - $the_title</title>", $header);
			print($header);
		}
	}
	
	/* "Paginas" del Utimate Tag Warrior 3 */
	if (function_exists(is_utwtag)) {
		if (is_tag())
		{
			global $utw;
			$tag_title=$utw->FormatTags($utw->GetCurrentTagSet(),array('first'=>'%tagdisplay%', 'default'=> ', %tagdisplay%'));
			$line=$tag_title." ".$the_title." ".$the_category_description;
			$the_kw[]=$tag_title;
			$the_keywords=$the_keywords.", ".$tag_title;
			$line=strtolower($line);
			$line = str_replace(" ", ",", $line);
			$line = str_replace($stop_words, " ", $line);
			$line = str_replace($dic_stop_words, " ", $line);
			$trozos = explode(",", $line);
			foreach ($trozos as $trozo) {
				$trozo=strtolower(trim ($trozo));
				if (!(in_array ($trozo, $the_kw)))
				{
					if (($trozo) && (strlen($trozo) > 2))
					{
						$the_kw[]=$trozo;
						$the_keywords.=", ".$trozo;
					}
				}
			}
			/* Metas */
			echo "<meta name=\"title\" content=\"".$tag_title." - ".$the_title."\" />\n";
			echo "<meta name=\"description\" content=\"".$tag_title." - ".$the_category_description."\" />\n";
			echo "<meta name=\"keywords\" content=\"".$the_keywords."\" />\n";
			/* Title */
			$header = ob_get_contents();
			ob_end_clean();
			$header = preg_replace("/<title>.*<\/title>/", "<title>$tag_title - $the_title</title>", $header);
			print($header);
			$utw3check=0;
		}
	}

	if(!is_home() && !is_single() && !is_page() && $utw3check) 
	{
		echo "<meta name=\"robots\" content=\"noindex,follow\" />\n";
	} else {
		echo "<meta name=\"robots\" content=\"index,follow\" />\n";
	}
}

function start() {
	ob_start();
}
add_action('wp_head','generate_metas');
start();	
?>